#include <avr/io.h>
#include <stdlib.h>
#include "UART.h"


inline void UART_Init() {
	UCR =(1 << TXEN | 1 << RXEN | 1<< RXCIE);
	UBRR = UBRR_VAL;

}

void UART_PutC(unsigned char c) {
	while(!(USR & (1<<UDRE)));
    UDR = c;
}
 
void UART_PutS(char *s) {
	while(*s) {
		UART_PutC(*s++);
	}
}

void UART_PutDHex(uint16_t hex) {
	uint16_t tmp;
	UART_PutS("0x");
	for(uint8_t i = 0; i < 4; i++) {
		tmp = hex & 0xF000; //foo ;)
		tmp >>= 12;
		tmp += (tmp < 10) ? 48 : 55;
		hex <<= 4;
		UART_PutC(tmp);
	}
}

void UART_PutHex(uint8_t hex) {
	uint8_t tmp;
	UART_PutS("0x");
	for(uint8_t i = 0; i < 2; i++) {
		tmp = hex & 0xF0;
		tmp >>= 4;
		tmp += (tmp < 10) ? 48 : 55;
		hex <<= 4;
		UART_PutC(tmp);
	}
}

void UART_PutNum(uint16_t num) {
	char buff[6];
	itoa(num, buff, 10);
	UART_PutS(buff);
}
